import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
var CELL_TYPE = {
  header: 'th',
  data: 'td'
};

var AtomTable = function AtomTable(_ref) {
  var _cx;

  var head = _ref.head,
      body = _ref.body,
      foot = _ref.foot,
      fullWidth = _ref.fullWidth;
  var hasHead = Boolean(head == null ? void 0 : head.length);
  var hasFoot = Boolean(foot == null ? void 0 : foot.length);
  var baseClass = 'react-AtomTable';
  var tableClass = cx("" + baseClass, (_cx = {}, _cx[baseClass + "--fullWidth"] = fullWidth, _cx));
  return /*#__PURE__*/React.createElement("table", {
    className: tableClass
  }, hasHead && /*#__PURE__*/React.createElement("thead", null, /*#__PURE__*/React.createElement("tr", null, head.map(function (element, index) {
    return /*#__PURE__*/React.createElement("th", {
      key: index,
      className: baseClass + "-cell " + baseClass + "-headerCell"
    }, element);
  }))), /*#__PURE__*/React.createElement("tbody", null, body.map(function (row, index) {
    return /*#__PURE__*/React.createElement("tr", {
      key: index
    }, row.map(function (cell, index) {
      var _cx2;

      var _cell$type = cell.type,
          Element = _cell$type === void 0 ? CELL_TYPE.data : _cell$type,
          _cell$content = cell.content,
          content = _cell$content === void 0 ? '' : _cell$content,
          isNowrap = cell.isNowrap,
          _cell$colspan = cell.colspan,
          colspan = _cell$colspan === void 0 ? 1 : _cell$colspan;
      var cellClassName = cx(baseClass + "-cell", (_cx2 = {}, _cx2[baseClass + "-cell--noWrap"] = isNowrap, _cx2));
      return /*#__PURE__*/React.createElement(Element, {
        key: index,
        className: cellClassName,
        colspan: colspan
      }, content);
    }));
  })), hasFoot && /*#__PURE__*/React.createElement("tfoot", null, /*#__PURE__*/React.createElement("tr", null, foot.map(function (element, index) {
    return /*#__PURE__*/React.createElement("td", {
      key: index,
      className: baseClass + "-cell"
    }, element);
  }))));
};

AtomTable.displayName = 'AtomTable';
export { CELL_TYPE as AtomTableTypes };
export default AtomTable;